<template>

  <!-- Table Container Card -->
  <b-card
    no-body
  >

    <div class="m-2">

      <!-- Table Top -->
      <b-row>

        <!-- Per Page -->
        <b-col
          cols="12"
          md="6"
          class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
        >
          <!-- <v-select
              v-model="statusFilter"
              :options="statusOptions"
              class="invoice-filter-select"
              placeholder="Select Status"
            >
              <template #selected-option="{ label }">
                <span class="text-truncate overflow-hidden">
                  {{ label }}
                </span>
              </template>
            </v-select> -->
        </b-col>

        <!-- Search -->
        <b-col
          cols="12"
          md="6"
        >
          <div class="d-flex align-items-center justify-content-end">
            <b-form-input
              v-model="searchQuery"
              class="d-inline-block mr-1"
              placeholder="Search..."
            />
            
            <b-button
            variant="primary"
            :to="{ name: 'apps-invoice-add'}"
          >
            Agregar Factura
          </b-button>
          </div>
        </b-col>
      </b-row>

    </div>

    <b-table
      :items="fetchInvoices"
      responsive
      :fields="tableColumns"
      :filter="searchQuery"
      primary-key="id"
      show-empty
      empty-text="No se encotraron registros"
      class="position-relative"
    >

      <!-- <template #head(invoiceStatus)>
        <feather-icon
          icon="TrendingUpIcon"
          class="mx-auto"
        />
      </template> -->

      <!-- Column: Id -->
      <template #cell(id)="data">
        <b-link
          :to="{ name: 'apps-invoice-preview', params: { id: data.item.id }}"
          class="font-weight-bold"
        >
          #{{ data.value }}
        </b-link>
      </template>

    
      <!-- Column: Actions -->
      <template #cell(Acciones)="data">

         <div class="text-nowrap">
          <!-- <feather-icon
            :id="`invoice-row-${data.item.id}-send-icon`"
            icon="SendIcon"
            class="cursor-pointer"
            size="16"
          />
          <b-tooltip
            title="Send Invoice"
            class="cursor-pointer"
            :target="`invoice-row-${data.item.id}-send-icon`"
          /> -->

          <feather-icon
            :id="`invoice-row-${data.item.id}-preview-icon`"
            icon="EyeIcon"
            size="16"
            class="mx-1"
            @click="$router.push({ name: 'apps-invoice-preview', params: { id: data.item.id }})"
          />
          <b-tooltip
            title="Preview Invoice"
            :target="`invoice-row-${data.item.id}-preview-icon`"
          />

          <!-- Dropdown -->
          <b-dropdown
            variant="link"
            toggle-class="p-0"
            no-caret
          >

            <template #button-content>
              <feather-icon
                icon="MoreVerticalIcon"
                size="14"
                class="align-middle text-body"
              />
            </template>
            <!-- <b-dropdown-item>
              <feather-icon icon="DownloadIcon" />
              <span class="align-middle ml-50">Descargar</span>
            </b-dropdown-item> -->
            <b-dropdown-item v-if="data.item.status_id === 1" :to="{ name: 'apps-invoice-edit', params: { id: data.item.id } }">
              <feather-icon icon="EditIcon" />
              <span class="align-middle ml-50">Editar</span>
            </b-dropdown-item>
            <b-dropdown-item v-if="data.item.status_id === 5">
              <feather-icon icon="TrashIcon" />
              <span class="align-middle ml-50"  @click="deleteInvoice(data.item.id)">Eliminar</span>
            </b-dropdown-item>
          </b-dropdown>
        </div> 
      </template>

    </b-table>
    <div class="mx-2 mb-2">
      
    </div>
  </b-card>

</template>

<script>
import {
  BCard, BRow, BCol, BFormInput, BButton, BTable, BMedia, BAvatar, BLink,
  BBadge, BDropdown, BDropdownItem, BPagination, BTooltip,
} from 'bootstrap-vue'
import vSelect from 'vue-select'

export default {
  components: {
    BCard,
    BRow,
    BCol,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BPagination,
    BTooltip,

    vSelect,
  },
  data() {
    return {
      fetchInvoices:[],
      tableColumns :[
        { key: 'id', label: '#', sortable: true },
        { key: 'quote_date',label: 'Fecha', sortable: true },
        { key: 'client.name',label: 'Cliente', sortable: true },
        { key: 'estado.name',label: 'Estado', sortable: true },
        { key: 'Acciones' },
      ],
      searchQuery:'',
    }
  },
  methods:{
    getInvoices(){
      this.$http.get('invoice').then(res=>{
        this.fetchInvoices = res.data.invoices
      }).catch(err=>{
        console.log(err);
      })
    },
    deleteInvoice(id){
      this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          let parametros = {id: id};
          this.$http.get("invoice/delete", { params: parametros }).then((res) => {
            if(res.data.message === 'eliminado'){
              this.$swal({
                icon: 'success',
                title: 'Eliminado!',
                text: 'El registro ha sido eliminado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
              this.getInvoices()
            }else{
              this.$swal({
                title: 'Error!',
                text: ' No se pudo eliminar!',
                icon: 'error',
                customClass: {
                  confirmButton: 'btn btn-primary',
                },
                buttonsStyling: false,
              })
            }
            
          }).catch(err=>{
            console.log(err);
          })

          
        } else if (result.dismiss === 'cancel') {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
      })
    }
  },
  mounted(){
    this.getInvoices()
  }
}
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}

.invoice-filter-select {
  min-width: 190px;

  ::v-deep .vs__selected-options {
    flex-wrap: nowrap;
  }

  ::v-deep .vs__selected {
    width: 100px;
  }
}
</style>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
